<?php
/*
 Plugin Name: Online users
 * Plugin URI: https://www.tigaman.com/
 * Description: tigaman webdesign - This plugin displays the number of users on the website in a widget 
 * Version: 1.0
 * Author: tigaman webdesign
 * Author URI: https://www.tigaman.hu
 * Text Domain: twd-online-users
 * Domain Path: languages
 */
?>
<?php add_action( 'init', 'twdou_load_textdomain' );
function twdou_load_textdomain() {load_plugin_textdomain( 'twd-online-users', false, dirname( plugin_basename( __FILE__ ) ) . '/languages' ); }?>
<?php add_filter( 'plugin_action_links_' . plugin_basename(__FILE__), 'twdou_settings_link' );
function twdou_settings_link( array $links ) {
    $url = get_admin_url() . "admin.php?page=OnlineUsers";
    $settings_link = '<a href="' . $url . '">' . __('Settings', 'twd-online-users') . '</a>';
      $links[] = $settings_link;
    return $links;
  }
?>
<?php 
register_activation_hook(__FILE__, 'who_is_online_install');
function who_is_online_install()
{
    global $wpdb;
    $who_is_online_table = $wpdb->prefix . 'who_is_online';
    $sql = 'CREATE TABLE ' . $who_is_online_table . ' (
  ip int(20) NOT NULL default \'0\',
  user_id bigint(20) default NULL,
  botname varchar(255) NOT NULL default \'\',
  path varchar(255) NOT NULL default \'\',
  first_visit bigint(20) NULL default NULL,
  last_visit bigint(20) NULL default NULL,
  view_count bigint(20) NOT NULL default \'0\',
  PRIMARY KEY (ip)
);';
    require_once (ABSPATH . 'wp-admin/includes/upgrade.php');
    dbDelta($sql);
    add_option('who_is_online_version', '0.1.5');
    add_option('who_is_online_time_before_off', '5');
}

/*
 * Code that handles the plugin deactivation
 */

register_deactivation_hook(__FILE__, 'who_is_online_uninstall');
function who_is_online_uninstall()
{
    global $wpdb;
    $who_is_online_table = $wpdb->prefix . 'who_is_online';
    $sql = 'DROP TABLE ' . $who_is_online_table;
    $wpdb->query($sql);
    delete_option('who_is_online_version');
    delete_option('who_is_online_time_before_off');
}

/*
 * Code that automatically upgrades the plugin
 */

if (version_compare(get_option('who_is_online_version'), '0.1.5', '<'))
{
    who_is_online_update();
}
function who_is_online_update()
{
    global $wpdb;
    $who_is_online_table = $wpdb->prefix . 'who_is_online';
    $sql = 'CREATE TABLE ' . $who_is_online_table . ' (
  ip int(20) NOT NULL default \'0\',
  user_id bigint(20) default NULL,
  botname varchar(255) NOT NULL default \'\',
  path varchar(255) NOT NULL default \'\',
  first_visit bigint(20) NULL default NULL,
  last_visit bigint(20) NULL default NULL,
  view_count bigint(20) NOT NULL default \'0\',
  PRIMARY KEY (ip)
);';
    require_once (ABSPATH . 'wp-admin/includes/upgrade.php');
    dbDelta($sql);
    update_option('who_is_online_version', '0.1.5');
}

/*
 * Code for the admin page widget
 */

add_action('wp_dashboard_setup', 'who_is_online_add_dashboard_widget');
function who_is_online_add_dashboard_widget()
{
    wp_add_dashboard_widget('who_is_online_dashboard_widget', __('Online Users', 'twd-online-users'), 'online_users_dashboard_widget');
}
function online_users_dashboard_widget()
{
    global $wpdb;
    $members_s = '';
    $guests_text = '';
    $person = __('person', 'twd-online-users');
    $who_is_online_table = $wpdb->prefix . 'who_is_online';
    $guests_sql = 'SELECT COUNT(*) AS user_count FROM ' . $who_is_online_table . ' WHERE user_id IS NULL;';
    $members_sql = 'SELECT COUNT(user_id) AS user_count FROM ' . $who_is_online_table . ';';
    $result = $wpdb->get_row($members_sql);
    $members = $result->user_count;
    $result2 = $wpdb->get_row($guests_sql);
    $guests = $result2->user_count;
//    $total_users = $members + $guests;
//    printf(_n('There is currently %d person online.', 'There is currently %d people online.', $total_users, 'twd-online-users'), $total_users);
     echo '<div class="onlineusers">';
    echo '<p>';
    echo'' . __('There is currently', 'twd-online-users') . '';
    echo '</p>';
//    echo '<p>';	
//    printf(_n('%d Member.', '%d Members.', $members, 'twd-online-users'), $members);
//    echo '</p>';
    echo '<p> ☆ ';	
    echo '<span class="counting">';
    printf(_n('%d ', '%d ', $guests, 'twd-online-users'), $guests);
    echo '</span>';    echo ' ☆ </p>';
    echo '<p>';
	echo'' . __('Users Online', 'twd-online-users') . '';	;	
    echo '</p>';		
    echo '</div>';

}

/*
 * Code that handles the plugin options page
 */

add_action('admin_menu', 'who_is_online_add_options_page');
function who_is_online_add_options_page()
{
    if(function_exists('add_options_page'))
    {
 
add_options_page('Online Users',__('Online Users', 'twd-online-users'),  8, 'OnlineUsers', 'online_users_options_page');



    }
}
function online_users_options_page()
{
    if(isset($_POST['minutes']) and !empty($_POST['minutes']))
    {
        if(ctype_digit($_POST['minutes']))
        {
            update_option('who_is_online_time_before_off', $_POST['minutes']);
            echo '<div id="message" class="updated fade"><p><strong>'.__('Options saved', 'twd-online-users').'</strong></p></div>';
        }
        else
        {
            echo '<div id="message" class="updated fade"><p><strong>'.__('You entered an invalid value', 'twd-online-users').'</strong></p></div>';
        }
    }
    echo who_is_online_output_options_page();
}
function who_is_online_output_options_page()
{?>
<div class="wrap"> 
    <h2><?php _e('Online Users', 'twd-online-users'); ?></h2>	
   <form method="post">
    <fieldset class="options" name="general">
      <legend><?php _e('General settings', 'twd-online-users'); ?></legend>
      <table width="100%" cellspacing="2" cellpadding="5" class="editform">
        <tr>
          <th nowrap valign="top" width="33%"><?php _e('Minutes Before Offline', 'twd-online-users'); ?></th>
          <td><input type="text" name="minutes" id="minutes" value="<?php echo ''. get_option('who_is_online_time_before_off') . ''?>" /> <span class="description">
  <?php _e('Determines how much time will pass before someone is considered offline. ', 'twd-online-users'); ?>
        
         
         </span>
          </td>
        </tr>
      </table>
    </fieldset>
    <p class="submit">
	<input type="submit" name="Submit" class="button-primary" value="<?php _e('Save Changes', 'twd-online-users'); ?>" />
	</p>
  </form>

 <h1>See more free stuff - tigaman webdesign</h1>
          
<style type="text/css">
@import url('https://fonts.googleapis.com/css2?family=Roboto:wght@100;300;500&display=swap');
.wrap {
	box-shadow: 0 0 5px rgba(0,0,0,.3);
	padding: 30px;
	font-family: 'Roboto', sans-serif;
	background: url("data:image/svg+xml;charset=utf8,%3C?xml version='1.0' encoding='UTF-8' standalone='no'?%3E%3C!DOCTYPE svg PUBLIC '-//W3C//DTD SVG 1.1//EN' 'http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd'%3E%3Csvg version='1.1' id='Layer_1' xmlns='http://www.w3.org/2000/svg' xmlns:xlink='http://www.w3.org/1999/xlink' x='0px' y='0px' width='250px' height='75px' viewBox='0 0 250 75' enable-background='new 0 0 250 75' xml:space='preserve'%3E%3Cimage id='image0' width='250' height='75' x='0' y='0' href='data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAPoAAABLCAQAAADzc1JmAAAABGdBTUEAALGPC/xhBQAAACBjSFJN AAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAAmJLR0QA/4ePzL8AAAAJcEhZ cwAACxIAAAsSAdLdfvwAAAAHdElNRQfmCBwXGSyWx4HXAAADzXpUWHRSYXcgcHJvZmlsZSB0eXBl IHhtcAAAeJztnU1yozAQhfc6RY4gd+sHHwcb2E3VLOf481pkbAfjxDGZqkdVhwpgIbX66x82b0H4 8+t3eHt7O0gXJehZp9rVWA5Fy6nkmiQWKbnUciyjDiLjdDqdJhGMH0uykVw1p0FjGmpMirldOYbU 1b5iYdbapzGngisMqmKRiE46xl7PtdO+dgULy2CblYNE+13OZaxqz4LtAG9SmcwP7ecHl+nNk6sZ jJ1sRbqskJi7NOQYxJybahvSLKOqDPAn6kGxq4IXYwdNmu0eY2eMSnsuMuE6n0uQoU3r28QeU6rE xSGGN98DUuALZmZJKZUrYGiE80OD7GrCEbUH1FTbn4wVk2Rsflfsf9CjHRd/BOchzEZkqFqRJYtL 7QCHSNnzqy9Lj+AOkofUSDla7AJSOpURLr5PQOAFeyPU5iEi3d+hvh+LrFku7qGaR+M1m7hHSsoA 3A4+RwNEEqJldfY6LPexmmnG+2RuZyxLFp1sJqdy1vE29YA42qxaQwvhCftHyzCSHaXLraptOmKt ctRz8+RT82EtBqte5ZTmq46tjlqucK3tfAg5YQjhwr/VUVTN/QMPbkzdbx8+7D/AzQSsUo+f7C+a LttH7Voxw6OP+6+aWtaSTPfVFOZymqvp+fK7r77wSvlhsS5rL8DNCENSztdusok4ZyzM9kKx1kEZ zEV4uBbhItiG0PboS2mmBouNjnAfd3hTZtsMdVUtOmszF5W9HsT1GN7OnV8oYX6VWt6WL9O1anl8 3PXaq8f/MvQdGHq012H40D6yMHi0wdBnidkd2vNVtgO0V1uGEu1n+p8D7ZaFw6MNhh4nZodoz1bZ LtBeaxlStJ/ofxa0KwuLRxsMPUrMLtGeq7KdoL3SMrRo2/ufB+0fC49HGwytJ2anaM9U2W7Qvt8y xGhb+58JbWZh8miDobXE7Bbt6yrbEdp3W4YabVv/c6GtKjV7RVsVWPaK9lWV7Qrtey1Djral/9nQ Ys/m0QZDq4rfXtE+r7KdobmYyYrmYiYpmouZrGguZpKiuZjJiuZiJiuai5mkaC5msqK5mEmK5mIm K5qLmaxoLmaSormYyYrmYiYpmouZrGguZrKiuZhJiuZiJiuai5msaC5mkqK5mMmK5mImKZqLmaxo LmayormYSYrmYiYrmouZpGguZrKiuZjJiuZiJimai5msaC5mkqK5mMmK5mImK5qLmaRoLmayormY yYrmYiYpmouZrGguZpKiuZjJiuZi5j/pcPUDKtk+MmGfJKh1/vZJ+AtO+opWFFIRmgAABx1JREFU eNrtnDFoKmsWgL99WFhYWAhrYSG8FBYXVriBDdzAtUiRhcBaCM8HFi64kCKFxS0sLFzIgxSBTZHC IsuzCKwLeZDCwiKFRQoLC4sscUFIHi9glpvFgAEvzIWzReaamWRi9CbjJDfnq3TmOOfMP/9//vOf /4ygKIqiKIqiKIqiKIqiKIqiKIqifMPEOKFH0GszlNkRoYdg6EN/TdQQhAOvzVBmRwpBEFJeG6JA jpUZaPHRRRC6+Ly+YSWE0JqBnqw5zvNe37ACSYR117V8Gec9/F7fsAJbCPOua8noOH9ONDmbgZaW jvPngx+DsutaFsxxvub17SoACYRl17VUNG53l+kadoFPNJ5I8xyfHKeKID8AsM8yIXxEgAAhi8Q5 Lfb57EFrfSP8birpGr4nG+k13vMfzrgEggQ5JYiPz/yBKNDhFz4Dl1xafhPBT5QYb/mJotdN91ro P+E8GyJBgkWiRGzHDxEM3oz9bY6E103xWphDiLmsI4IgbHh9q8oXMjNYrhUROrpUc5fvxpyL2sIn mJ/BjtcKV6T5BEBQH/4sCbBG606WvUXWdb0GW6Nvv7EzxW9DJLSTjJhnhwpl8ixMIh5iiz6CcETG ctzHkDmXTU0hLI2+TbOXXmCIsPsI3eHR8nXB9cjFfcpmgksQzsiPGw4+8vQRBpTvZNjjXMzA1IHF vMqEniVADaFI5hEWpkcbSXsIBmHX79VdgiRIkGadOkOEo/sGbIQmwkeKjgVKOWqum9qZSsccJfao 0ja3ZhIMHeXibFJhnSibNO5Z7HUQMkDeHB2LD+j2k6PCDiskqFNxlJln51ZU5A0BVuly5JSIi9HD YOPeirRtNl02LmTbV1uhM9bNFjAsLmyPMGlOHeTWbXJiiRluiCP08BFlwD6C3Mod3G2rju2a4thq VbPzLNOi/cAV3SZA427xS4geJ2M3TRusumxYErE4oQ4yJghZRxCqXCG06CEUKdC8R+43M58vCDmH q5UQdoA6TTIIg7F2XhdsCnscj2ZNJ/oM8ZPHwEBmsFE1no27k+UOxw/MY10+3DqyauvrfU455ZCG KTf+rLNZ3dHnNwjte+SS7CIYpKkiHBEgyCphqqNALs4HdmlQRxCOiXOMcMkFcifXF2ODE4RlVhDi rJurliBpS1D5BT/b5qPOk0cY8Ik+e3ek0uwh1E2ZBE0+OrjX1Xszi0/dtiF6N0PoiyEpFjgf+9Cz d863+BtXDsFTa4KzTsSpjz4vgkPs7iNJgbcA/MQCP3DOCldAGYhRAVYo8ZZ/c4Gfd8AFP/JPYvxC mgA9y0ZNhBQp3nFFgM80afEv2uSBNkv8TAT4kapFf4A670zt8Heu+BOHbBC1WJggzZ8J8T8gMpIp 8zPLtoglwg7v+es9bfG0bRtin19v+8HoTOreHuLCMuuUkFvuKMoGZ3ykTM4MN4WBZUIKIKSp0SNv hk9BDIQixwg1s3uvckiOHFu0uWCfAgvMIzTJYjAHNBAaGBis0uLIZsExfY4QOhQRDDPcC9FknSwf 2OeCNtukCbOJIBgkAfBzYtufzPKRqutL4GsWOWHgFB+d2dbkXhDCIDD6toaMYgg/KWr02SWJj+ui yYGlQa9ZQuhTtlwjjmDQQzi0HL1ezCQsk1kGocyJmQrqmA8rxXWUETelUvSpEWEf4WwkcaMrQYK4 ZcG5hyAULE0/YBM/AVIcsj+6rruE2UHoOa9GsgiHZO6N3eddL2lYsLmfMH0aJMhR4ZBNliz605bH ckMJ41aoGWRovi4RGKeYEkKbodkN2rbqvDo1oixxQNv0QxsIwuDBevzGnWRRjG0aVFmbUSQ/xxZD hMb9+nL0EQza7FKiRNpyLo6w7bKJmVuLqQh5CiQdwssAu9Rv9d0YfQcL0zQoPthdK7alXI5TS0Dk p0CFbUsVQZDqROO0SO2BzuYe177xus4wO140TIlTS/LuhixCx2VDC46LqckIc4LYnP00lBEGLz4H d0OSAYJwOj79amWOJFmytok/wsGY5cDTsDXZ1oADPg4wHvGiYxZx/e5mSZpL9lh5CTWGla+e6YoM OHBIzEzOy99geaHsf+Xv4hgUOKfk9Q28HL57/CU8xUeZX2nxe0tiR3mA5+P3Lwl9xdZohj/yF5b4 76Pcu+IRm19R4eqnRxcf3alqbF49z8e9t2yZgclYJcw2b/h+Bnv9igsEuJjyXyd8dOnjZ8tWb6O8 KHKIZXP1YZJmHu3sUbVxiscsT5WVqyPEWHpELk55YYQxaAJV+urcXwt5hDVCDD0vRFJmxgFChA9j K+mUb4oAQ5pA11bbokzE81mnT8cifg5I8r0699fDOsISDQb6z7HT81JH+hvAz3v+YfunCuWbpsU5 rRm8Uqk8I67Lutx+0Up5VtQQjj0rPFQ8IUz2WbwRqiiKoiiKoiiKoiiKoiiKoii3+T/j/qjtmGlT CAAAABZ0RVh0Q3JlYXRpb24gVGltZQAwNy8wMi8yMq1LEssAAAAldEVYdGRhdGU6Y3JlYXRlADIw MjItMDgtMjhUMjM6MjU6NDQrMDA6MDAepk1wAAAAJXRFWHRkYXRlOm1vZGlmeQAyMDIyLTA4LTI4 VDIzOjI1OjQ0KzAwOjAwb/v1zAAAACh0RVh0ZGF0ZTp0aW1lc3RhbXAAMjAyMi0wOC0yOFQyMzoy NTo0NCswMDowMDju1BMAAAATdEVYdGRjOmZvcm1hdABpbWFnZS9wbmf/uRs+AAAAHHRFWHRTb2Z0 d2FyZQBBZG9iZSBGaXJld29ya3MgQ1M26LyyjAAAACN0RVh0eG1wOkNyZWF0ZURhdGUAMjAyMi0w Ny0wMVQyMzozNjowM1q4jYmUAAAALXRFWHR4bXA6Q3JlYXRvclRvb2wAQWRvYmUgRmlyZXdvcmtz IENTNiAoV2luZG93cykoY/PJAAAAI3RFWHR4bXA6TW9kaWZ5RGF0ZQAyMDIyLTA3LTI0VDIzOjA4 OjUxWsSF4qsAAAAASUVORK5CYII='/%3E%3C/svg%3E"),repeating-radial-gradient(circle, transparent, transparent 11.2px, rgba(0, 0, 0, 0.008) 11.2px, rgba(0, 0, 0, 0.008) 14.4px), repeating-radial-gradient(circle, transparent, transparent 11.2px, rgba(0, 0, 0, 0.008) 11.2px, rgba(0, 0, 0, 0.008) 14.4px), rgba(255,255,255,1);
	background-position: right 15px top 10px, 0 0;
	background-repeat: no-repeat, repeat;
	background-size: auto,  1640px 640px;
}
h1 {	font-weight: 200;}
h2 {	font-weight: 300;}
 #tigamandotcom {width: 100%;height:500px;overflow-x: hidden;}
 #footer-thankyou, #footer-upgrade{display:none;}
table {
	width: 100%;
	max-width: 100%;
	margin: 20px 0;

}
tr {
	border-bottom:1px dotted  rgba(0,0,0,.2);	
	box-shadow: 0 5px 5px -5px rgba(0,0,0,.2);	
}
th {font-weight: 300;	letter-spacing: 1.5px;	
	text-transform: capitalize;}
table input {
	width: calc(100% - 20px);
	padding: 10px;
	margin: 0 0px;	font-weight: 400;
}


 </style>       
            <embed id="tigamandotcom" type="text/html" src="https://www.tigaman.com/">  <div style="clear: both; width: 100%; height: 1px;"></div> </div>
 <?php
}

/*
 * Code for the visitor sidebar widget
 */


class online_users_Widget extends WP_Widget {

	// Main constructor
	public function __construct() {
		parent::__construct(
			'online_users_widget',
			__( 'Online users' ),
			array(
				'customize_selective_refresh' => true,
			)
		);
	}
	
	// Display the widget
	public function widget( $args, $instance 
	
	)	
	
	


{
    global $wpdb;
    $who_is_online_table = $wpdb->prefix . 'who_is_online';
    extract($args);
    $guests_sql = 'SELECT COUNT(*) AS user_count FROM ' . $who_is_online_table . ' WHERE user_id IS NULL;';
    $members_sql = 'SELECT COUNT(user_id) AS user_count FROM ' . $who_is_online_table . ';';
    $result = $wpdb->get_row($members_sql);
    $members = $result->user_count;
    $result2 = $wpdb->get_row($guests_sql);
    $guests = $result2->user_count;
    echo $before_widget;
    echo $before_title;
    echo  __('Online users', 'twd-online-users') . '';
    echo $after_title;
    echo '<div class="onlineusers">';
    echo '<p>';
    echo'' . __('There is currently', 'twd-online-users') . '';
    echo '</p>';
//    echo '<p>';	
//    printf(_n('%d Member.', '%d Members.', $members, 'twd-online-users'), $members);
//    echo '</p>';
    echo '<p> ☆ ';	
    echo '<span class="counting">';
    printf(_n('%d ', '%d ', $guests, 'twd-online-users'), $guests);
    echo '</span>';    echo ' ☆ </p>';
    echo '<p>';
	echo'' . __('Users Online', 'twd-online-users') . '';	;	
    echo '</p>';		
    echo '</div>';
    echo $after_widget;
}
}

// Register the widget
function twdou_register_custom_widget() {
	register_widget( 'online_users_Widget' );
}
add_action( 'widgets_init', 'twdou_register_custom_widget' );


/*
 * Code that handles logging activity
 */

add_action('get_header', 'who_is_online_upload_activity');
add_action('admin_head', 'who_is_online_upload_activity');
function who_is_online_upload_activity()
{
    who_is_online_cleanup();
    global $user_ID;
    if(who_is_online_real_ip() == $_SERVER['SERVER_ADDR'])
    {
        return;
    }
    else
    {
        global $wpdb;
        $who_is_online_table = $wpdb->prefix . 'who_is_online';
        $botname = who_is_online_get_botname($_SERVER['HTTP_USER_AGENT']);
        if(empty($user_ID))
        {
            $id = 'NULL';
        }
        else
        {
            $id = $wpdb->escape($user_ID);
        }
        $ip = ip2long(who_is_online_real_ip());
        $sql = 'INSERT INTO ' . $who_is_online_table . ' (ip, user_id, botname, path, first_visit, last_visit, view_count) VALUES (\'' . $ip . '\', ' . $id . ', \'' . $botname . '\', \'' . $wpdb->escape($_SERVER['REQUEST_URI']) . '\' , '.time().', '.time().', 1) ON DUPLICATE KEY UPDATE path=\'' . $wpdb->escape($_SERVER['REQUEST_URI']) . '\', view_count=view_count+1, user_id=' . $id . ', last_visit = '.time().';';
        $wpdb->query($sql);
    }
}

/*
 * Misc functions
 */
add_filter('the_author', 'who_is_online_maybe_author');
function who_is_online_maybe_author($username)
{
	global $wpdb;
	$check_online = $wpdb->get_results('SELECT t2.id AS id FROM '.$wpdb->prefix.'who_is_online AS t1 LEFT JOIN '.$wpdb->prefix.'users AS t2 ON t1.user_id = t2.id WHERE t2.user_login = \''.$wpdb->escape($username).'\';');
	if ($check_online) {
		$username = $username . ' ('.__('online', 'twd-online-users').')';
	}
	return $username;
}

function who_is_online_real_ip()
{
    if((isset($_SERVER['HTTP_X_FORWARDED_FOR']) && !empty($_SERVER['HTTP_X_FORWARDED_FOR'])) && long2ip(ip2long($_SERVER['HTTP_X_FORWARDED_FOR'])))
    {
        $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
    }
    elseif(long2ip(ip2long($_SERVER['REMOTE_ADDR'])))
    {
        $ip = $_SERVER['REMOTE_ADDR'];
    }
    else
    {
        $ip = '127.0.0.1';
    }
    return $ip;
}
function who_is_online_get_botname($user_agent)
{
    $bots = array('Alexa' => 'ia_archiver', 'All The Web' => 'FAST-WebCrawler', 'All The Web' => 'crawler@fast', 'Altavista' => 'Scooter', 'Ask.com' => 'Ask Jeeves/Teoma', 'DMOZ' => 'Robozilla', 'Exite' => 'Architext spider', 'Google' => 'Googlebot', 'Infoseek' => 'InfoSeek sidewinder', 'Inktomi' => 'Slurp', 'Look Smart' => 'MantraAgent', 'Lycos' => 'Lycos_Spider', 'MSN Search' => 'MSNbot', 'Teoma' => 'Teoma_agent', 'Yahoo' => 'Yahoo Slurp', 'Web Crawler' => 'WebCrawler', 'Wise Nut' => 'ZyBorg');
    if(empty($user_agent))
    {
        $botname = '';
    }
    else
    {
        foreach($bots as $bot => $bot_match)
        {
            if(stristr($user_agent, $bot_match))
            {
                $botname = $bot;
                break;
            }
        }
    }
    return $botname;
}
function who_is_online_time_convert($seconds)
{
    $time = '';
    if($seconds > 3600)
    {
        $hours = ($seconds - ($seconds % 3600)) / 3600;
        $seconds = $seconds % 3600;
        $time .= $hours . ':';
    }
    $minutes = str_pad(($seconds - ($seconds % 60)) / 60, 2, 0, STR_PAD_LEFT);
    $seconds = str_pad($seconds % 60, 2, 0, STR_PAD_LEFT);
    $time .= $minutes . ':' . $seconds;
    return $time;
}
function who_is_online_cleanup()
{
    global $wpdb;
    $who_is_online_table = $wpdb->prefix . 'who_is_online';
    $sql = 'DELETE FROM ' . $who_is_online_table . ' WHERE ('.time().'-' . get_option('who_is_online_time_before_off') * 60 . ') > last_visit';
    $wpdb->query($sql);
}
?>
<?php 
// CSS file
add_action('wp_enqueue_scripts', 'twdou_plugin_styles');
  function twdou_plugin_styles() {
    wp_register_style('twdou', plugins_url('twd-online-users.css',__FILE__));
    wp_enqueue_style('twdou'); }
	
 // Admin files
add_action('admin_head', 'twdouadmin');

function twdouadmin() {?>
    <link rel="stylesheet" href="<?php echo plugin_dir_url( __FILE__ ) . ''; ?>twd-online-users.css" type="text/css" media="all" />
<?php }?>